package com.hfkj.service;

import com.hfkj.entity.BsProductConfig;

import java.util.List;
import java.util.Map;

public interface BsProductConfigService {

    /**
     * @MethodName create
     * @Description:创建
     * @param productConfig
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    void create(BsProductConfig productConfig);

    /**
     * @MethodName update
     * @Description:更新
     * @param productConfig
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    void update(BsProductConfig productConfig);

    /**
     * @MethodName delete
     * @Description:删除
     * @param id
     * @param fullDelete
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    void delete(Long id , Boolean fullDelete);

    /**
     * @MethodName queryDetail
     * @Description:根据id查询
     * @param id
     * @return: com.hfkj.entity.BsProductConfig
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    BsProductConfig queryDetail(Long id);

    /**
     * @MethodName queryDetailByProductType
     * @Description:根据产品类型查询
     * @param productType
     * @return: com.hfkj.entity.BsProductConfig
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    BsProductConfig queryDetail(Integer productType);

    /**
     * @MethodName queryDetailByMap
     * @Description:根据map查询
     * @param map
     * @return: com.hfkj.entity.BsProductConfig
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    BsProductConfig queryDetailByMap(Map<String , Object> map);

    /**
     * @MethodName getList
     * @Description:根据map查询列表
     * @param merId
     * @return: java.util.List<com.hfkj.entity.BsProductConfig>
     * @Author: Sum1Dream
     * @Date: 2024/7/3 下午5:20
     */
    List<BsProductConfig> getList(Long merId);

}
