package com.hfkj.service.order;

import com.alibaba.fastjson.JSONObject;
import com.hfkj.common.exception.ErrorCode;
import com.hfkj.common.exception.ErrorHelp;
import com.hfkj.common.exception.SysCode;
import com.hfkj.config.CommonSysConst;
import com.hfkj.entity.BsOrderChild;
import com.hfkj.entity.BsOrderCinema;
import com.hfkj.model.order.OrderChildModel;
import com.hfkj.model.order.OrderModel;
import com.hfkj.qianzhu.channel.CinemaService;
import com.hfkj.service.goods.BsOrderCinemaService;
import com.hfkj.sysenum.order.OrderChildProductTypeEnum;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;


/**
  * @ClassName OrderRefundSuccessService
  * @Author Sum1Dream
  * @Description 退款成功业务处理
  * @Date 2024/7/4 下午5:31
 **/
@Component
public class OrderRefundSuccessService {

    @Resource
    private BsOrderCinemaService bsOrderCinemaService;

    /**
     * 订单业务处理
     * @param orderChild
     * @throws Exception
     */
    public void orderRefundHandle(OrderChildModel orderChild) {
        try {
            if (orderChild.getProductType().equals(OrderChildProductTypeEnum.type1.getCode())) {
                // todo 实物产品退款业务
            } else if (orderChild.getProductType().equals(OrderChildProductTypeEnum.type2.getCode())) {
                // todo 虚拟产品退款业务
            } else if (orderChild.getProductType().equals(OrderChildProductTypeEnum.type3.getCode())) {
                // 电影票退款业务
                cinema(orderChild);
            }
        } catch (Exception e) {
            throw ErrorHelp.genException(SysCode.System , ErrorCode.COMMON_ERROR , e.getMessage());
        }
    }

    public void cinema(BsOrderChild childOrder) {
        // 查询电影票订单
        BsOrderCinema orderCinema = bsOrderCinemaService.findGoodsOrder(childOrder.getOrderNo());

        try {

            if (orderCinema != null) {
                Map<String , Object> map = new HashMap<>();
                map.put("orderNo", childOrder.getOrderNo());
                JSONObject object = CinemaService.refundMovieOrder(map);
                System.out.println("=========================================");
                System.out.println(object);
                orderCinema.setStatus(-5);
                orderCinema.setExceptionStatus(false);
                bsOrderCinemaService.update(orderCinema);
            }
        } catch (Exception e) {
            orderCinema.setExceptionStatus(true);
            orderCinema.setExceptionMsg(e.getMessage());
            bsOrderCinemaService.update(orderCinema);
            throw ErrorHelp.genException(SysCode.System , ErrorCode.COMMON_ERROR , e.getMessage());
        }

    }
}
